Package org.apache.axiom.blob

# Interface MemoryBlob

All Superinterfaces:
  `Blob`, `WritableBlob`

public interface MemoryBlob extends WritableBlob
Blob that stores data in memory.

This interface redefines several methods from `Blob` and `WritableBlob` to not throw `IOException`. Also note that since data is stored in memory, calling `WritableBlob.release()` is not required.

Instances are created with `Blobs.createMemoryBlob()` or using `FACTORY`.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final WritableBlobFactory<MemoryBlob>`
  `FACTORY`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MemoryBlobInputStream`
  `getInputStream()`
  Get an input stream to read the data in the blob.
  `MemoryBlobOutputStream`
  `getOutputStream()`
  Create an output stream to write data to the blob.
  `long`
  `getSize()`
  Get the (approximate) size of the blob.
  `MemoryBlobInputStream`
  `readOnce()`
  Get an input stream that consumes the content of this blob.
  `void`
  `release()`
  Release all resources held by this blob.

  ### Methods inherited from interface org.apache.axiom.blob.Blob

  `writeTo`

  ### Methods inherited from interface org.apache.axiom.blob.WritableBlob

  `readFrom`

- ## Field Details

  - ### FACTORY

    static final WritableBlobFactory<MemoryBlob> FACTORY

- ## Method Details

  - ### getInputStream

    MemoryBlobInputStream getInputStream()
    Description copied from interface: `Blob`
    Get an input stream to read the data in the blob. A new `InputStream` object is returned each time this method is called, and the stream is positioned at the beginning of the data.
    Specified by:
      `getInputStream` in interface `Blob`
    Returns:
      the input stream to read the data from

  - ### getOutputStream

    MemoryBlobOutputStream getOutputStream()
    Description copied from interface: `WritableBlob`
    Create an output stream to write data to the blob. The blob must be in state NEW when this method is called. It will be in state UNCOMMITTED after this method completes successfully. Note that this implies that this method may be called at most once for a given blob instance.

    Calls to methods of the returned output stream will modify the state of the blob according to the following rules:

    - A call to `OutputStream.close()` will change the state to COMMITTED.
    - Calls to other methods will not modify the state of the blob. They will result in an `IOException` if the state is COMMITTED, i.e. if the stream has already been closed.

    The returned stream may implement `ReadFromSupport`, especially if the blob stores its data in memory (in which case `ReadFromSupport.readFrom(InputStream, long)` would read data directly into the buffers managed by the blob).

    Specified by:
      `getOutputStream` in interface `WritableBlob`
    Returns:
      an output stream that can be used to write data to the blob

  - ### getSize

    long getSize()
    Description copied from interface: `Blob`
    Get the (approximate) size of the blob. Returns -1 if the size can't be determined without reading the entire blob (in which case the caller may want to use `Blob.writeTo(OutputStream)` with an `OutputStream` that counts the number of bytes to determine the size). The method may choose to return a value based on an estimation. This may be the case e.g. if reading the data involves a decoding operation, and the length of the resulting stream can't be determined precisely without performing the decoding operation.

    When reading the actual data, the code should always read until the end of the stream is reached (as indicated by the return value of the `read` methods of the `InputStream` class). It must be prepared to reach the end of the stream after a number of bytes that is lower or higher than the value returned by this method.

    Specified by:
      `getSize` in interface `Blob`
    Returns:
      the number of bytes in the blob, or -1 if the size is not known

  - ### release

    void release()
    Description copied from interface: `WritableBlob`
    Release all resources held by this blob. This method will put the blob into the RELEASED state and the content will no longer be accessible.
    Specified by:
      `release` in interface `WritableBlob`

  - ### readOnce

    MemoryBlobInputStream readOnce()
    Get an input stream that consumes the content of this blob. The memory held by this blob will be gradually released as data is read from the stream.
    Returns:
      the input stream to read the data from